<template>
  <div>
    <GManageTable
      :card="card"
      :level="level"
      :i18n-base="i18nBase"
      v-bind="$attrs"
      :headers="headers"
      :items="value.result"
      use-wrapper
      :wiki-entry="wikiEntry"
      :get-new-item="getNewItem"
      @create="create"
      @edit="edit"
      @remove="remove"
    >
      <template #form="{ item, updateAvailableElements }">
        <DccResult
          v-model="item.value"
          :update-available-elements="updateAvailableElements"
        />
      </template>

      <template #[`item.name`]="{ item }">
        {{ getForCurrentLocale(item.name) }}
      </template>
      <template #[`item.description`]="{ item }">
        <div class="text-truncate default-max-width">
          {{ getForCurrentLocale(item.description) }}
        </div>
      </template>
    </GManageTable>
  </div>
</template>

<script>
import { validatableMixin } from "../../Mixins/validatableMixin";
import { generateResult } from "~/assets/util/DataGenerator";
import { removeFromArray } from "~/assets/util/general";
import { localizationMixin } from "~/components/Mixins/localizationMixin";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable";
import DccResult from "~/components/DCC/MeasurementResults/DccResult";

export default {
  name: "DccResults",
  components: {
    GManageTable,
    DccResult,
  },
  mixins: [validatableMixin, localizationMixin],
  props: {
    value: Object,
    card: {
      type: Boolean,
      default: true,
    },
    level: String,
    i18nBase: {
      type: String,
      default: "dcc.measurementResults.resultListType",
    },
    wikiEntry: {
      type: String,
      default: "results",
    },
  },
  data() {
    return {
      headers: [
        {
          text: this.$t("dcc.common.attributes.refType"),
          value: "_attr.refType",
        },
        {
          text: this.$t("dcc.measurementResults.resultType.name"),
          value: "name",
        },
        {
          text: this.$t("dcc.measurementResults.resultType.description"),
          value: "description",
        },
      ],
    };
  },
  computed: {
    customRules() {
      return [() => this.value.result.length > 0];
    },
  },
  watch: {
    "value.result"() {
      this.validate();
    },
  },
  methods: {
    remove(item) {
      removeFromArray(this.value.result, item);
    },
    create(item) {
      this.value.result.push(item);
    },
    edit(item, index) {
      this.$set(this.value.result, index, undefined);
      this.$set(this.value.result, index, item);
    },
    getNewItem() {
      return generateResult();
    },
  },
};
</script>
